%% definice obrazku a cesty k nim
clear all; close all; clc
images = {'1_1.tif' '1_2.tif' '2_2.tif' '2_7.tif' '3_1.tif' '3_5.tif' '10_1.tif'... % 1 - 7
'10_2.tif' '12_1.tif' '12_2.tif' '15_3.tif' '15_6.tif' '25_2.tif' '25_5.tif'... % 8 - 14
'33_2.tif' '33_6.tif' '40_2.tif' '40_5.tif'}; % 15 - 18
imdir = 'images';

% nacteni obrazku
% obr1 = 1;
% obr2 = 2;
% im1 = imread([imdir '/' images{obr1}]);
% im2 = imread([imdir '/' images{obr2}]);

%tvorba struktur se segmentaci, markanty, kostrou pro kazdy otisk
% imS = computeAuxVals(images, imdir, segWinSize, orientationWinSize);
% save images/imS imS;

%nacteni ulozenych struktur
load images/imS;
addpath ./kody_cv1


%% markantovy matching
%ukazka matchingu pro dvojici obrazku
o1 = 1; o2 = 2; % cisla obrazku

%zarovnani obrazku
[~, mAi2Align im2SkAlign] = ...
    align2(imS(o1).imageSkeleton, imS(o1).singularityPoints, imS(o2).imageSkeleton, imS(o2).minutiaArray, imS(o2).singularityPoints);

%vypocet ohodnoceni otisku
%%%             FUNKCE MATCH - ukol                  %%%
[matchingScore, nbmatch, inputmatch, dbmatch] = match(imS(o1).minutiaArray, mAi2Align);
%%%                      %%%                         %%%

%vykresleni zarovnanych koster s markanty
mtchim = showsimilarity(imcomplement(full(imS(o1).imageSkeleton)), imcomplement(full(im2SkAlign)));
figure; imshow(mtchim); hold on
[x1,y1]= find(dbmatch == 1); [x2,y2]= find(dbmatch == 2);
[x3,y3]= find(inputmatch == 1); [x4,y4]= find(inputmatch == 2);
plot(y1,x1,'ob','markersize',8); plot(y2,x2,'sb','markersize',8);
plot(y3,x3,'or','markersize',8); plot(y4,x4,'sr','markersize',8);
title(['markantovy matching ' imS(o1).name ' (' num2str(o1) ') x ' imS(o2).name ' (' num2str(o2)...
  '), score = ' num2str(matchingScore)], 'interpreter', 'none')

%% fingercode
%provede matching prvniho obrazku v databazi se vsemi ostatnimi a vykresli
%do grafu pro kazdou dvojici vysledne skore
Gfilt = GaborFilter_creation; %tvorba banky filtru
o1 = 1; score = zeros(length(imS), length(imS)-1);

%%%       FUNKCE FINGERCODE_CREATION - ukol          %%%
[fingercode1 Fm1] = fingercode_creation(imS(o1).im, Gfilt, getCore(imS(o1).singularityPoints));
%%%                      %%%                         %%%

%zde se postupne vyhodnoti dvojice obrazku a vysledek se ulozi do promenne
%mch, trva pomerne dlouho
for o2 = 2 : length(imS)
    %nejdrive zarovnani obrazku
    [mRi2Align mAi2Align im2SkAlign offset angle core] = ...
        align2(imS(o1).imageSkeleton, imS(o1).singularityPoints, imS(o2).imageSkeleton, imS(o2).minutiaArray, imS(o2).singularityPoints);
    im2Align = imrotatearound(imshift(imS(o2).im, offset), angle, core);
    
    %tvorba fingercodu
    [fingercode2 Fm2] = fingercode_creation(im2Align, Gfilt, getCore(imS(o1).singularityPoints));
    
    %vypocet skore
    D = abs(fingercode1 - fingercode2);
    matchingScoreG = mean(D); %% vysledne skore %%
    
    mch(o2 - 1) = matchingScoreG;
    
    if o2 == 2
        mtchim = showsimilarity(imcomplement(full(imS(o1).imageSkeleton)), imcomplement(full(im2SkAlign)));
    end
end

%vytvoreni grafu zobrazujiciho ro kazdou dvojici obrazku vysledne skore
figure; plot(2:length(imS), mch); xlabel('cislo obrazku'); ylabel('matching score'); title('fingercode matching')
figure; imshow(mtchim); title('zarovnane kostry otisku')

%%%% ukazka fingercodu, po odkomentovani je mozne si prohlednout filtrovane
%%%% otisky se zobrazenou oblasti mezikruzi
% figure; 
% for m = 1 : size(Fm1, 1), 
%     subplot(2,4,m); imshow(squeeze(Fm1(m, :, :)) / max(max(squeeze(Fm1(m, :, :))))); 
% end
% title('fingercode 1')
% figure; 
% for m = 1 : size(Fm2, 1),
%     subplot(2,4,m); imshow(squeeze(Fm2(m, :, :)) / max(max(squeeze(Fm2(m, :, :))))); 
% end
% title('fingercode 2')