addpath ./kody_cv1
clear all; clc

%nacteni obrazku
im1 = imread('./images/1_1.tif');
imS1 = auxiliaryValues(im1, '1_1.tif', 15, 15);

im2 = imread('./images/1_2.tif');
imS2 = auxiliaryValues(im2, '1_2.tif', 15, 15);

im3 = imread('./images/15_3.tif');
imS3 = auxiliaryValues(im3, '15_3.tif', 15, 15);

%zarovnani
[~, mAi2Align im2SkAlign offset2 angle2 core2] = ...
    align2(imS1.imageSkeleton, imS1.singularityPoints, imS2.imageSkeleton, imS2.minutiaArray, imS2.singularityPoints);
im2Align = imrotatearound(imshift(imS2.im, offset2), angle2, core2);
show_align(imS1.imageSkeleton, im2SkAlign);

[~, mAi3Align im3SkAlign offset3 angle3 core3] = ...
    align2(imS1.imageSkeleton, imS1.singularityPoints, imS3.imageSkeleton, imS3.minutiaArray, imS3.singularityPoints);
im3Align = imrotatearound(imshift(imS3.im, offset3), angle3, core3);
show_align(imS1.imageSkeleton, im3SkAlign);

%matching
[matchingScore1, nbmatch1, inputmatch1, dbmatch1] = match(imS1.minutiaArray, mAi2Align); %markantovy align
matchongScoreG1 = fingercode_score(imS1.im, imS1.singularityPoints, im2Align, imS2.singularityPoints); %fingercode align

[matchingScore2, nbmatch2, inputmatch2, dbmatch2] = match(imS1.minutiaArray, mAi3Align); %markantovy align
matchongScoreG2 = fingercode_score(imS1.im, imS1.singularityPoints, im3Align, imS3.singularityPoints); %fingercode align

%zobrazeni vystupu
disp(' ')
disp(['Skore markantoveho matchingu1: ' num2str(matchingScore1)]);
disp(['Skore fingercode matchingu1: ' num2str(matchongScoreG1)]);
disp(' ')
disp(['Skore markantoveho matchingu2: ' num2str(matchingScore2)]);
disp(['Skore fingercode matchingu2: ' num2str(matchongScoreG2)]);